<?php
session_start();
//https://stackoverflow.com/questions/13889198/php-avoid-browser-reposting-post-on-page-refresh/13889283#13889283
if( strcasecmp( $_SERVER['REQUEST_METHOD'],"POST" ) === 0 )
{
	$_SESSION['postdata'] = $_POST;
	header("Location: ".$_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);
	exit();
}

if ( !$_SESSION['postdata'] )
{
	//header("Location: ../");
	//exit();
}
if( isset( $_SESSION['postdata'] ) )
{
	$_POST = $_SESSION['postdata'];
	unset($_SESSION['postdata']);

}
?>
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>

<title>Password hashes and password cracking</title>

<meta name="viewport" content="user-scalable=1, width=device-width, initial-scale=1.0, maximum-scale=2.0, minimum-scale=1.0" />

<meta http-equiv="Content-type" content="text/html; charset=utf-8" />

<style>

table {
	/*width: 100%;*/
	width: 880px;
	overflow: hidden;
	table-layout: fixed;
	}
</style>

<link rel="stylesheet" type="text/css" href="styles.css" />

<link rel="stylesheet" type="text/css" href="form_styles.css" />

<script>
function getContact( inputstr )
{
	//alert(inputstr);
	makehash = document.getElementById('string');
	makehash.value = unescape(inputstr);
	window.location.hash = '#makehash';
}
function putHash(inputhash, hashtype)
{
	//alert(inputhash + '{' + hashtype + '}');
	hashstr = document.getElementById('hash_str');
	hashstr.value = unescape(inputhash);
	document.getElementById(hashtype).selected = "true";
	window.location.hash = '#selecthash';
}
function uuidv4()
{
	return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
		var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
		return v.toString(16).toUpperCase();
	});
}

</script>
</head>

<body>

<div id='loginDiv'>

<?php
include( 'menu.php' );
?>

<h3>Password hashes and password cracking</h3>

<form action="<?php echo filter_var($_SERVER['PHP_SELF'], FILTER_SANITIZE_STRING); ?>" id="theForm" enctype="multipart/form-data" method="POST">

<?php
$whatSalt = ( $_POST['salt'] <> '' ? $_POST['salt'] : 'B' );
if ( isset( $_POST['submit'] ) )
{
	$curTime = microtime(true);
	?>
	<div style="padding:0px;width:100%;overflow:hidden;">

	<fieldset>

	<legend>Password Hashes &amp; Cracking &mdash; Result</legend>

	<pre>
	<?php
	include('crack.php');

	$wordlist    = 'aka.csv';
	$start_line  = 0;
	$hash_str    = $_POST['hash_str']; //'5e3aea6495685f9d827fcde5fb44e25f';
	$hash_type   = $_POST['hash_type']; //'crypt';
	$left_salt   = $_POST['saltL'] = ( $_POST['saltL'] == '' ? '' : trim( $_POST['saltL'] ) ); // add checkbox to use left salt
	$right_salt  = $_POST['saltR'] = ( $_POST['saltR'] == '' ? '' : trim( $_POST['saltR'] ) ); // add checkbox to use right salt
	$output_file = 'guessed.txt';
	$whatSalt    = $_POST['salt'];
	
	switch ( $whatSalt )
	{
		case 'L':
			//echo 'Left Salt<br />';
			$right_salt = '';
			break;
		case 'R':
			//echo "Right Salt<br />";
			$left_salt = '';
			break;
		case 'B':
			//echo "Both Salt<br />";
			break;
		case 'N':
			//echo "No Salt<br />";
			$left_salt  = '';
			$right_salt = '';
			break;
		}

	$pre = printPreamble(
		$wordlist,
		$start_line,
		$hash_str,
		$hash_type,
		$left_salt,
		$right_salt,
		$output_file
	);

	if ( $_POST['string'] <> '' )
	{
		$stringWithSalt = printStringWithSalts ( $left_salt, $_POST['string'], $right_salt );
		echo '</pre>' . PHP_EOL;
		echo '<h3>To be hashed</h3>' . PHP_EOL;
		echo '<pre>' . PHP_EOL;
		echo '<p>' . $stringWithSalt . '</p>' . PHP_EOL;
	}

	if( $_POST['hash_str'] <> '' )
	{
		echo '</pre>' . PHP_EOL;
		echo '<h3>Cracked hash</h3>' . PHP_EOL;
		echo '<pre>' . PHP_EOL;
		$gekraakt = crack(
			$wordlist,
			$start_line,
			$hash_str,
			$hash_type,
			$left_salt,
			$right_salt,
			$output_file
		);
	}

	if( $_POST['string'] <> '' )
	{
		echo '</pre>' . PHP_EOL;
		echo '<h3>All hashes with : <span style="color: red;">' . htmlentities( $_POST['string'] ) . '</span></h3>' . PHP_EOL;
		echo '<p style="font-size:90%;">(Click a highlighted hash or copy/paste it in the <b><i>guess password</i></b> field &amp; choose the hashtype)</p>' . PHP_EOL;
		echo '<pre>' . PHP_EOL;
		$allHashes = printAllHashesOf( $left_salt . $_POST['string'] . $right_salt );
	}
	$timeConsumed = round( microtime( TRUE ) - $curTime, 3 );
	echo '</pre>' . PHP_EOL; 
	echo '<p>It took ' . $timeConsumed . ' seconds to process your input.</p>' . PHP_EOL;
	echo '<pre>' . PHP_EOL;
	?>
	</pre>

	</fieldset>

	</div>

	<br style="clear: both;" />

	<?php
}
?>

	<a name="selecthash"></a>

	<fieldset>
	<legend>Password Hashes &amp; Cracking &mdash; Input</legend>

	<div class="divLabel"><label for="hash_type">Select a Hash type</label></div>
	<div>
		<select id="hash_type" name="hash_type" class="select-css">
			<option id="crypt"  value="crypt" selected >Crypt</option>
			<option id="bcrypt" value="bcrypt">Bcrypt</option>
			<option id="md5"    value="md5md5">MD5</option>
			<option id="sha256" value="sha256">SHA256</option>
			<option id="gost"   value="gost">GOST</option>
		</select>
	</div>

	<br style="border:none; clear: both;" />

	<div class="divLabel"><label for="hash_str">And paste the Hash here</label></div>
	<div class="divInput">
		<input
			type="text"
			id="hash_str"
			name="hash_str"
			value=""
			size="50"
			maxlength="100"
			placeholder="to guess password"
		/>
	</div>

	</fieldset>
	
	<br style="border:none; clear: both;" />

	<a name="makehash"></a>

	<fieldset>

	<legend>See all possible hashes</legend>

	<div class="divLabel"><label for="string">Type some text here</label></div>
	<div class="divInput">
		<input
			type="text"
			id="string"
			name="string"
			value=""
			size="50"
			maxlength="100"
			placeholder="or click a line below to see all hashes"
		/>
	</div>

	</fieldset>

<!--  BEGIN salt fields etc -->

	<br style="border:none; clear: both;" />

	<fieldset>

	<legend>Salt left &amp; right (click on the <span style="color:red;font-size:120%">O</span> to generate a salt)</legend>

	<div class="divLabel"><span class="pointer" style="color:red;font-size:120%" onclick="var guid = uuidv4(); document.getElementById('saltL').value = guid;">O </span> <label for="saltL">Left Salt</label></div>
	<div class="divInput">
		<input
			type="text"
			id="saltL"
			name="saltL"
			value="<?php echo $_POST['saltL']; ?>"
			size="50"
			maxlength="100"
			placeholder="Left Salt"
		/>
	</div>

	<br style="border:none; clear: both;" />

	<div class="divLabel"><span class="pointer" style="color:red;font-size:120%" onclick="var guid = uuidv4(); document.getElementById('saltR').value = guid;">O </span> <label for="saltR">Right Salt</label></div>
	<div class="divInput">
		<input
			type="text"
			id="saltR"
			name="saltR"
			value="<?php echo $_POST['saltR']; ?>"
			size="50"
			maxlength="100"
			placeholder="Right Salt"
		/>
	</div>

	<br style="clear: both;" />

	<div class="divLabel">Use</div>
	<div class="divInputRadio">
		<input type="radio" name="salt" value="L" <?php echo ( $whatSalt == 'L' ? 'checked' : '' ); ?> style="vertical-align: middle" /> Left Salt<br /><br />
		<input type="radio" name="salt" value="R" <?php echo ( $whatSalt == 'R' ? 'checked' : '' ); ?> style="vertical-align: middle" /> Right Salt<br /><br />
		<input type="radio" name="salt" value="B" <?php echo ( $whatSalt == 'B' ? 'checked' : '' ); ?> style="vertical-align: middle" /> Both Salts<br /><br />
		<input type="radio" name="salt" value="N" <?php echo ( $whatSalt == 'N' ? 'checked' : '' ); ?> style="vertical-align: middle" /> No Salts
	</div>

	</fieldset>


<!-- END salt fields etc -->
	<br style="clear: both;" />

	<fieldset>

	<div class="divLabel"><label for="submit"></label></div>
	<div class="divInput">
		<input
			type="submit"
			id="submit"
			name="submit"
			value="submit"
		/>
	</div>

	</fieldset>

</form>

<p>For <a href="https://en.wikipedia.org/wiki/Dictionary_attack" target="_blank"><code><i>dictionary attack</i></code></a> (<a href="https://nl.wikipedia.org/wiki/Woordenlijstaanval" target="_blank"><code><i>NL</i></code></a>) demo purposes, click one of the lines below.</p>

<code style="font-size:100%;">
<?php
$handle = @fopen("aka.csv", "r");
if ( $handle )
{
	$teller = 1;
	while (( $buffer = fgets( $handle, 4096 ) ) !== false )
	{
		$text = str_replace(array("\n", "\r"), '', $buffer);
?>
<script>var str<?php echo $teller; ?> = escape( "<?php echo $text; ?>" );</script>
<span class="pointer" onclick="getContact( str<?php echo $teller; ?> );"><?php echo $text; ?></span><br />
<?php
	$teller++;
	}
	if ( !feof( $handle ) )
	{
		echo "Error: unexpected fgets() fail\n";
	}
	fclose( $handle );
}
?>
</code>

<p>Source &#x27a0; <a href="https://defuse.ca/php-hash-cracker.htm" target="_blank">https://defuse.ca/php-hash-cracker.htm</a><br />
Github &#x27a0; <a href="https://github.com/defuse/phphashcrack" target="_blank">https://github.com/defuse/phphashcrack</a></p>

<p>Download &#x27a0; <a href="hashes.zip"><code>zip file</code></a> with this PHP file, the dictionary file and an edited <code>crack.php</code> file.</p>

</div>

</body>

</html>